#include "NeuralNetwork.hpp"

torch::Device NeuralNetworkImpl::device(torch::cuda::is_available() ? torch::kCUDA : torch::kCPU);

float NeuralNetworkImpl::entropy(torch::Tensor probabilities)
{
  if (probabilities.dim() != 1)
    util::myThrow("Invalid probabilities tensor");

  probabilities = torch::clamp(probabilities.unsqueeze(0), 0.00000000001, 1.0);
  float entropy = -torch::sum(probabilities * torch::log(probabilities)).item<float>();

  return entropy;
}

